//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrTomato
#property indicator_color3  clrBlack
#property indicator_color4  clrGreen
#property indicator_color5  clrBlue
#property indicator_color6  clrBrown
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                TMA1Period      = 13;
extern ENUM_APPLIED_PRICE TMA1Price       = PRICE_CLOSE;
extern int                TMA2Period      = 26;
extern ENUM_APPLIED_PRICE TMA2Price       = PRICE_CLOSE;
extern bool               alertsOn        = false;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = false;
extern bool               alertsSound     = false;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";
extern int                ArrowCodeUp     = 159;      // Arrow code up
extern int                ArrowCodeDn     = 159;      // Arrow code down
extern double             ArrowGapUp      = 0.5;      // Gap for arrow up        
extern double             ArrowGapDn      = 0.5;      // Gap for arrow down
extern int                UpArrowSize     = 2;
extern int                DnArrowSize     = 2;
extern bool               ArrowOnFirst    = true;     // Arrow on first bars

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double trend[];
double arrowu[];
double arrowd[];
double cross[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,arrowu);  SetIndexStyle(4,DRAW_ARROW,0,UpArrowSize); SetIndexArrow(4,ArrowCodeUp);
   SetIndexBuffer(5,arrowd);  SetIndexStyle(5,DRAW_ARROW,0,DnArrowSize); SetIndexArrow(5,ArrowCodeDn);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,cross);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit(){ return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
            if (returnBars)  { buffer3[0] = limit+1; return(0); } 
            
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {  
     for(int i=limit; i>=0; i--)
     {
        buffer1[i] = iTma(iMA(NULL,0,1,0,MODE_SMA,TMA1Price,i),TMA1Period,i,0);
        buffer2[i] = iTma(iMA(NULL,0,1,0,MODE_SMA,TMA2Price,i),TMA2Period,i,1);
        buffer3[i] = buffer1[i];
        buffer4[i] = buffer2[i];
        arrowu[i]  = EMPTY_VALUE;
        arrowd[i]  = EMPTY_VALUE;
        trend[i]   = 0;
        cross[i]   = cross[i+1];
        
           if (Close[i]<buffer1[i] && Close[i]>buffer2[i]) trend[i] = 1;
           if (Close[i]>buffer1[i] && Close[i]<buffer2[i]) trend[i] =-1;
           if (buffer1[i]>buffer2[i])                      cross[i] = 1;
           if (buffer1[i]<buffer2[i])                      cross[i] =-1;
           if (i<Bars-1 && cross[i]!=cross[i+1])
           {
              if (cross[i] ==  1) arrowu[i] = MathMin(buffer1[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
              if (cross[i] == -1) arrowd[i] = MathMax(buffer1[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
           }
         
     }
   
     //
     //
     //
     //
     //
   
     if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1)   doAlert(whichBar,"price between TMA's");
            if (trend[whichBar] ==-1)   doAlert(whichBar,"price between TMA's");
         }
      }         
    return(0);
    }
    
    //
   //
   //
   //
   //
 
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
    for(i=limit; i >= 0; i--)  
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
       int x = y;
      if (ArrowOnFirst)
            {  if (i<Bars-1) x = iBarShift(NULL,TimeFrame,Time[i+1]);          }
      else  {  if (i>0) x = iBarShift(NULL,TimeFrame,Time[i-1]); else x = -1;  }
          buffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TMA1Period,TMA1Price,TMA2Period,TMA2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ArrowCodeUp,ArrowCodeDn,ArrowGapUp,ArrowGapDn,UpArrowSize,DnArrowSize,0,y);
          buffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TMA1Period,TMA1Price,TMA2Period,TMA2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ArrowCodeUp,ArrowCodeDn,ArrowGapUp,ArrowGapDn,UpArrowSize,DnArrowSize,1,y);
          buffer3[i] = buffer1[i];
          buffer4[i] = buffer2[i];       
          arrowu[i]  = EMPTY_VALUE;
          arrowd[i]  = EMPTY_VALUE;
       if (x!=y)
       {
          arrowu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TMA1Period,TMA1Price,TMA2Period,TMA2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ArrowCodeUp,ArrowCodeDn,ArrowGapUp,ArrowGapDn,UpArrowSize,DnArrowSize,4,y);
          arrowd[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TMA1Period,TMA1Price,TMA2Period,TMA2Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ArrowCodeUp,ArrowCodeDn,ArrowGapUp,ArrowGapDn,UpArrowSize,DnArrowSize,5,y);
       }
    }
return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTma[][2];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workTma,0)!= Bars) ArrayResize(workTma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TMA ribbon filled ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " TMA ribbon filled "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

      

